
int op(int a, int b)
{
    return a + b;
} 

__kernel void reduce(__global int* data, const int stage)
{
    uint id = get_global_id(0);
    uint blockSize = get_local_size(0);
    uint blockId = id / blockSize;
    uint threadId = get_local_id(0);
        
    for(uint s = blockSize; s > 0; s >>= 1)
    {
        if(threadId < s)
        {
            int m = op(data[stage * (2 * blockId * blockSize + threadId)], data[stage * (2 * blockId * blockSize + threadId + s)]);
            data[stage * (2 * blockId * blockSize + threadId)] = m;
        }
        barrier(CLK_GLOBAL_MEM_FENCE);
    }
}

__kernel void reduce2(__global int* data, const int stage)
{
    uint id = get_global_id(0);
    uint blockSize = get_local_size(0);
    uint blockId = id / blockSize;
    uint threadId = get_local_id(0);
        
    for(uint s = 1; s <= blockSize; s <<= 1)
    {
        if((threadId % s) == 0)
        {
            int m = op(data[stage * (2 * id)], data[stage * (2 * id + s)]);
            data[stage * (2 * blockId * blockSize + 2 * threadId)] = m;
        }
        barrier(CLK_GLOBAL_MEM_FENCE);
    }
}

__kernel void reduce3(__global int* data, const int stride, const int odd)
{
    uint id = get_global_id(0);
        
    uint first = 2 * id * stride;
    uint second = first + stride;
    
    int val = max(data[first], data[second]);
    
    if(odd && id == (get_global_size(0)-1))
    {
        val = max(val, data[second + stride]);
    }
    
    data[first] = val;
}
 
 